apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ awx_name }}-scripts
  namespace: {{ namespace }}
data:
  launch-awx-task: |
    #!/usr/bin/env bash
    if [ `id -u` -ge 500 ]; then
        echo "awx:x:`id -u`:`id -g`:,,,:/var/lib/awx:/bin/bash" >>/tmp/passwd
        cat /tmp/passwd >/etc/passwd
        rm /tmp/passwd
    fi

    if ls /certs/*.crt >/dev/null 2>&1; then
        ls /certs/*.crt | while read f
            do
                cat "$f" >"/etc/pki/ca-trust/source/anchors/$(basename $f)"
            done
        update-ca-trust
    fi

    source /etc/tower/conf.d/environment.sh

    ANSIBLE_REMOTE_TEMP=/tmp ANSIBLE_LOCAL_TEMP=/tmp ansible -i "127.0.0.1," -c local -v -m wait_for -a "host=$DATABASE_HOST port=$DATABASE_PORT" all
    ANSIBLE_REMOTE_TEMP=/tmp ANSIBLE_LOCAL_TEMP=/tmp ansible -i "127.0.0.1," -c local -v -m wait_for -a "path=/var/run/redis/redis.sock" all

    if [ -z "$AWX_SKIP_MIGRATIONS" ]; then
        awx-manage migrate --noinput
    fi

    if [ ! -z "$AWX_ADMIN_USER" ] && [ ! -z "$AWX_ADMIN_PASSWORD" ]; then
        echo "from django.contrib.auth.models import User; User.objects.create_superuser('$AWX_ADMIN_USER', 'root@localhost', '$AWX_ADMIN_PASSWORD')" | awx-manage shell
    else
        echo "from django.contrib.auth.models import User; User.objects.create_superuser('admin', 'root@localhost', 'password')" | awx-manage shell
    fi
    awx-manage create_preload_data
    echo 'from django.conf import settings; x = settings.AWX_TASK_ENV; x["HOME"] = "/var/lib/awx"; settings.AWX_TASK_ENV = x' | awx-manage shell
    awx-manage provision_instance --hostname=$(hostname)
    awx-manage register_queue --queuename=tower --instance_percent=100

    unset $(cut -d = -f -1 /etc/tower/conf.d/environment.sh)

    supervisord -c /supervisor_task.conf
  launch-awx-web: |
    #!/usr/bin/env bash
    if [ `id -u` -ge 500 ]; then
        echo "awx:x:`id -u`:`id -g`:,,,:/var/lib/awx:/bin/bash" >>/tmp/passwd
        cat /tmp/passwd >/etc/passwd
        rm /tmp/passwd
    fi

    if ls /certs/*.crt >/dev/null 2>&1; then
        ls /certs/*.crt | while read f
            do
                cat "$f" >"/etc/pki/ca-trust/source/anchors/$(basename $f)"
            done
        update-ca-trust
    fi

    source /etc/tower/conf.d/environment.sh

    ANSIBLE_REMOTE_TEMP=/tmp ANSIBLE_LOCAL_TEMP=/tmp ansible -i "127.0.0.1," -c local -v -m wait_for -a "host=$DATABASE_HOST port=$DATABASE_PORT" all
    ANSIBLE_REMOTE_TEMP=/tmp ANSIBLE_LOCAL_TEMP=/tmp ansible -i "127.0.0.1," -c local -v -m wait_for -a "path=/var/run/redis/redis.sock" all

    awx-manage collectstatic --noinput --clear

    unset $(cut -d = -f -1 /etc/tower/conf.d/environment.sh)

    supervisord -c /supervisor.conf
  init-ldap-job: |
    #!/usr/bin/env bash

    OPENLDAP_BIND_DN_PREFIX="${OPENLDAP_BIND_DN_PREFIX:-cn=awx,ou=services}"
    OPENLDAP_BIND_PW="${OPENLDAP_BIND_PW:-secret}"
    OPENLDAP_DOMAIN=${OPENLDAP_DOMAIN:-demo.local}
    OPENLDAP_HOST=${OPENLDAP_HOST:-}
    OPENLDAP_PROTO=${OPENLDAP_PROTO:-ldap}
    OPENLDAP_USERS_OBJECTCLASS=${OPENLDAP_USERS_OBJECTCLASS:-inetOrgPerson}
    POSTGRES_DB=${POSTGRES_DB:-awx}
    POSTGRES_HOST=${POSTGRES_HOST:-127.0.0.1}
    POSTGRES_PASS=${POSTGRES_PASS:-secret}
    POSTGRES_PORT=${POSTGRES_PORT:-5432}
    POSTGRES_USER=${POSTGRES_USER:-awx}
    if test -z "$OPENLDAP_BASE"; then
        OPENLDAP_BASE=`echo "dc=$OPENLDAP_DOMAIN" | sed 's|\.|,dc=|g'`
    fi
    if test -z "$OPENLDAP_PORT" -a "$OPENLDAP_PROTO" = ldaps; then
        OPENLDAP_PORT=636
    elif test -z "$OPENLDAP_PORT"; then
        OPENLDAP_PORT=389
    fi
    #FIXME: encrypt LDAP password
    #see https://github.com/ansible/awx/blob/devel/awx/main/utils/encryption.py
    ENCPW=FIXME
    (
        echo "DELETE FROM public.conf_setting WHERE key LIKE '%AUTH_LDAP%'";
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_SERVER_URI',\"$OPENLDAP_PROTO://$OPENLDAP_HOST:$OPENLDAP_PORT\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_BIND_DN',\"$OPENLDAP_BIND_DN_PREFIX,$OPENLDAP_BASE\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_BIND_PASSWORD',\"\$encrypte\d$UTF8\$AESCBC\$$ENCPW\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_START_TLS',\"false\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_USER_DN_TEMPLATE',\"uid=%(user)s,ou=users,$OPENLDAP_BASE\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_USER_ATTR_MAP',\"{\\\"first_name\\\": \\\"givenName\\\", \\\"last_name\\\": \\\"sn\\\", \\\"email\\\": \\\"mail\\\"}\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_REQUIRE_GROUP',\"\\N\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_DENY_GROUP',\"\\N\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_USER_FLAGS_BY_GROUP',\"{\\\"is_superuser\\\": [\\\"cn=Admins,ou=groups,$OPENLDAP_BASE\\\"]}\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_ORGANIZATION_MAP',\"{}\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_TEAM_MAP',\"{}\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_USER_SEARCH',\"[\\\"ou=users,$OPENLDAP_BASE\\\", \\\"SCOPE_SUBTREE\\\", \\\"(&(uid=%(user)s)(objectClass=$OPENLDAP_USERS_OBJECTCLASS))\\\"]\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_GROUP_SEARCH',\"[\\\"ou=groups,$OPENLDAP_BASE\\\", \\\"SCOPE_SUBTREE\\\", \\\"(objectClass=groupOfNames)\\\"]\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_GROUP_TYPE',\"MemberDNGroupType\",\"\\N\")"
        echo "INSERT INTO public.conf_setting (created, modified, key, value, user_id) VALUES (now(), now(), 'AUTH_LDAP_GROUP_TYPE_PARAMS',\"{\\\"name_attr\\\": \\\"cn\\\", \\\"member_attr\\\": \\\"member\\\"}\",\"\\N\")"
    ) | PGPASSWORD=$POSTGRES_PASS psql -U "$POSTGRES_USER" -h "$POSTGRES_HOST" -p "$POSTGRES_PORT" "$POSTGRES_DB"
  init-awx-job: |
    #!/usr/bin/env bash
    if test "$DEBUG"; then
        set -x
    fi
    if ! awx-manage migrate --noinput; then
        echo Failed migrating database
    else
        AWX_ADMIN_USER=${AWX_ADMIN_USER:-admin}
        AWX_ADMIN_PASSWORD=${AWX_ADMIN_PASSWORD:-password}
        if ( echo "from django.contrib.auth.models import User;";
             echo "nsu = User.objects.filter(is_superuser=True).count(); exit(0 if nsu > 0 else 1);";
            ) | awx-manage shell; then
            awx-manage update_password --username="$AWX_ADMIN_USER" --password="$AWX_ADMIN_PASSWORD"
        else
            if ! ( echo "from django.contrib.auth.models import User;"; \
                   echo "User.objects.create_superuser('$AWX_ADMIN_USER', 'root@localhost', '$AWX_ADMIN_PASSWORD')"; \
                 ) | awx-manage shell; then
                echo Failed initializing AWX initial admin account
            elif ! awx-manage create_preload_data; then
                echo Failed initializing site
            fi
        fi
        if test "$POSTGRES_PASS" -a "$OPENLDAP_BIND_PW" -a -s /init-ldap.sh; then
            . /init-ldap.sh
        fi
    fi
